unit MenuPrincipal;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, FileSplitter, ExtCtrls, ComCtrls, ActnList, shellapi, shlobj, registry;

type
  TformTrocear = class(TForm)
    FileSplitter: TFileSplitter;
    dialogoAbrir: TOpenDialog;
    GroupBox1: TGroupBox;
    Label2: TLabel;
    txtFicheroTrocear: TEdit;
    bSeleccionarFicheroTrocear: TButton;
    Label1: TLabel;
    txtTamano: TEdit;
    Label3: TLabel;
    GroupBox2: TGroupBox;
    Label4: TLabel;
    txtFicheroUnir: TEdit;
    bSeleccionarFicheroUnir: TButton;
    txtFicheroUnido: TEdit;
    Label5: TLabel;
    btnSplit: TButton;
    LWEB: TLabel;
    lVersion: TLabel;
    opDisquetes: TCheckBox;
    lstUnidadDisquete: TComboBox;
    lnombreficherotroceado: TLabel;
    txtFicheroTroceado: TEdit;
    lTamanoFichero: TLabel;
    lNumTrozos: TLabel;
    txtMegas: TEdit;
    Label6: TLabel;
    bUnirTrozos: TButton;
    lNumeroTrozos: TLabel;
    bAsociarExtension: TButton;
    GroupBox3: TGroupBox;
    bProgreso: TProgressBar;
    lProceso: TLabel;
    procedure btnSplitClick(Sender: TObject);
    procedure bUnirTrozosClick(Sender: TObject);
    procedure bSeleccionarFicheroTrocearClick(Sender: TObject);
    procedure LWEBClick2(Sender: TObject);
    procedure bSeleccionarFicheroUnirClick(Sender: TObject);
    procedure FileSplitterProgress(Sender: TObject; PercentDone: Word);
    procedure FileSplitterNeedDisk(Sender: TObject; DiskID,
      NumOfDisks: Word; var Continue: Boolean);
    procedure FormShow(Sender: TObject);
    procedure opDisquetesClick(Sender: TObject);
    procedure tamanoFicheroNumTrozos();
    procedure txtTamanoChange(Sender: TObject);
    procedure txtFicheroTrocearChange(Sender: TObject);
    procedure txtMegasChange(Sender: TObject);
    procedure txtMegasKeyPress(Sender: TObject; var Key: Char);
    procedure txtTamanoKeyPress(Sender: TObject; var Key: Char);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure bAsociarExtensionClick(Sender: TObject);
    procedure lstUnidadDisqueteChange(Sender: TObject);
  private
    deDisquete : boolean;  //si el trozo proviene de disquete
    trocear : boolean; //operacin que se va a realizar
    { Private declarations }
  public
    { Public declarations }
  end;

var
  formTrocear: TformTrocear;

implementation

uses UnidadProcedimientos;

{$R *.DFM}

procedure TformTrocear.btnSplitClick(Sender: TObject);
begin
  trocear := true;
  if txtFicheroTrocear.Text = '' then
  begin
    MessageDlg('Debe especificar el fichero a trocear.',
        mtWarning, [mbok], 0);
    txtFicheroUnir.SetFocus;
  end
  else
  begin
    if FileExists(txtFicheroTrocear.Text) then
    begin
      FileSplitter.SplitFileName := txtFicheroTroceado.Text;
      FileSplitter.FileName := txtFicheroTrocear.Text;
      try
        FileSplitter.Size := StrToInt(txtTamano.Text);
      except
        on EConvertError do
        begin
          Screen.Cursor := crDefault;
          MessageDlg('"' + txtTamano.Text + '" no es un nmero vlido.',
              mtWarning, [mbok], 0);
          txttamano.SetFocus;
        end;
      end;
      FileSplitter.NombreFicheroOriginal := txtFicheroTrocear.Text;
      if  MessageDlg('Se va a trocear el fichero ' + chr(13) + chr(13) +
          txtFicheroTrocear.Text + chr(13) + chr(13) + 'en' +
          chr(13) + chr(13) + txtFicheroTroceado.Text + chr(13) + chr(13) +
          'Pulse Aceptar para continuar con el proceso.',
          mtInformation, [mbOK, mbcancel], 0) = mrok then
      begin   
        if FileExists(txtFicheroTroceado.Text) then
        begin
          if MessageDlg('Atencin: ya existe el fichero ' + chr(13) + chr(13) +
              txtFicheroTroceado.Text + chr(13) + chr(13) +
              'Desea reemplazarlo por el trozo resultante?',
              mtConfirmation, [mbyes,mbno], 0) = mryes then
          begin
            Screen.Cursor := crHourGlass;
            FileSplitter.Split;
            Screen.Cursor := crDefault;
            MessageDlg('El proceso de troceado del fichero' + chr(13) + chr(13) +
                txtFicheroTrocear.Text + chr(13) + chr(13) +
                ' ha finalizado correctamente.',
                mtInformation, [mbok], 0);
          end;
        end
        else
        begin
          Screen.Cursor := crHourGlass;
          FileSplitter.Split;
          Screen.Cursor := crDefault;
          MessageDlg('El proceso de troceado del fichero' + chr(13) + chr(13) +
              txtFicheroTrocear.Text + chr(13) + chr(13) +
              ' ha finalizado correctamente.',
              mtInformation, [mbok], 0);
        end;
      end;
    end
    else
    begin
      Screen.Cursor := crDefault;
      MessageDlg('El fichero seleccionado para trocear [' +
          txtFicheroTrocear.Text + '] no existe.', mtWarning, [mbok], 0);
      txtFicheroTrocear.SetFocus;
    end;
  end;
  bProgreso.Position := 1;
  lProceso.Caption := '';
  Screen.Cursor := crDefault;
end;

procedure TformTrocear.bUnirTrozosClick(Sender: TObject);
begin
  trocear := false;
  if txtFicheroUnir.Text = '' then
  begin
    MessageDlg('Debe especificar el fichero a Unir.',
        mtWarning, [mbok], 0);
    txtFicheroUnir.SetFocus;
  end
  else
  begin
    if FileExists(txtFicheroUnir.Text) then
    begin
      if not DirectoryExists(ExtractFilePath(txtFicheroUnido.Text)) then
      begin
        MessageDlg('No existe la carpeta ' + chr(13) + chr(13) +
            ExtractFilePath(txtFicheroUnido.Text) +
            chr(13) + chr(13)+ ' donde desea unir el fichero. Para realizar este proceso deber crearla antes.',
            mtError, [mbok], 0);
        exit;
      end;

      FileSplitter.FileName := txtFicheroUnido.Text;
      FileSplitter.SplitFileName := txtFicheroUnir.Text;
      if (ExtractFileDrive(txtFicheroUnir.Text) = 'A:') or
          (ExtractFileDrive(txtFicheroUnir.Text) = 'B:')then
        deDisquete := true
      else
        deDisquete := false;
      if messagedlg ('Se van a unir los ficheros:' + chr(13) + chr(13) +
          txtFicheroUnir.Text + chr(13) + chr(13) +' en la ruta y fichero: '
          + chr(13) + chr(13) + txtFicheroUnido.Text + chr(13) + chr(13) +
          'Pulse Aceptar para continuar con el proceso.',
          mtInformation, [mbOK, mbcancel], 0) = mrok then
      begin
        if FileExists(txtFicheroUnido.Text) then
        begin
          if MessageDlg('Atencin: ya existe el fichero ' + chr(13) + chr(13) +
              txtFicheroUnido.Text + chr(13) + chr(13) +
              'Desea reemplazarlo por el resultante de la unin de los trozos?',
              mtConfirmation, [mbyes,mbno], 0) = mryes then
          begin
            FileSplitter.UnSplit;
            MessageDlg('El fichero ' + chr(13) + chr(13) + txtFicheroUnir.Text  +
                chr(13) + chr(13)+ 'ha sido Unido correctamente en el fichero ' +
                chr(13) + chr(13) + txtFicheroUnido.Text,
                mtInformation, [mbok], 0);
          end;
        end
        else
        begin
          FileSplitter.UnSplit;
          MessageDlg('El fichero ' + chr(13) + chr(13) + txtFicheroUnir.Text  +
              chr(13) + chr(13)+ 'ha sido Unido correctamente en el fichero ' +
              chr(13) + chr(13) + txtFicheroUnido.Text,
              mtInformation, [mbok], 0);
        end;
      end;
    end
    else
    begin
      MessageDlg('El fichero [' + txtFicheroUnir.Text + '] no existe.',
          mtWarning, [mbok], 0);
      txtFicheroUnir.SetFocus;
    end;
  end;
  bProgreso.Position := 1;
  lProceso.Caption := '';  
  deDisquete := false;  
end;

procedure TformTrocear.bSeleccionarFicheroTrocearClick(Sender: TObject);
begin
  dialogoAbrir.Title := 'Seleccione fichero a Trocear...';
  dialogoAbrir.Filter := 'Todos los ficheros (*.*)|*.*';
  if dialogoAbrir.Execute then
  begin
    txtFicheroTrocear.Text := dialogoAbrir.FileName;
    opDisquetesClick(nil);
    tamanoFicheroNumTrozos();
  end;
end;

procedure TformTrocear.tamanoFicheroNumTrozos();
var
  mb, tamano, tamanoFT : Double;
begin
  try
    lNumTrozos.Font.Color := clTeal;
    tamano := strtofloat(txttamano.text);
    if FileExists(txtFicheroTrocear.Text) then
    begin
      tamanoFT := tamanoFichero(txtFicheroTrocear.Text);
      if (tamanoFT > 0) and (tamano > 0)  then
        if opDisquetes.Checked then
        begin
          if Frac(tamanoFT / tamano) > 0 then
            lNumTrozos.Caption := 'Nmero de disquetes (aproximado): ' +
                FormatFloat('#,##0""', (tamanoFT / tamano) + 1)
          else
            lNumTrozos.Caption := 'Nmero de disquetes (aproximado): ' +
                FormatFloat('#,##0""', (tamanoFT / tamano));
        end
        else
          if Frac(tamanoFT / tamano) > 0 then
            lNumTrozos.Caption := 'Nmero de trozos (aproximado): ' +
                FormatFloat('#,##0""', (tamanoFT / tamano) + 1)
          else
            lNumTrozos.Caption := 'Nmero de trozos (aproximado): ' +
                FormatFloat('#,##0""', (tamanoFT / tamano))
      else
        if opDisquetes.Checked then
          lNumTrozos.Caption := 'Nmero de disquetes: 0'
        else
          lNumTrozos.Caption := 'Nmero de trozos: 0';
      lTamanoFichero.Caption := FormatFloat('#,##0.000" MB"', tamanoFT / 1048576);
    end
    else
    begin
      lNumTrozos.Font.Color := clRed;
      lNumTrozos.Caption := 'El fichero a trocear no existe.';
      lTamanoFichero.Caption := '';
    end;
  except
    on EConvertError do
    begin
      lNumTrozos.Font.Color := clRed;
      lNumTrozos.Caption := 'El nmero introducido para el tamao no es correcto.';
      exit;
    end;
  end;
  mb := tamano / 1048576;
  if not (txtMegas.Focused) and (txtTamano.Focused) then
    txtMegas.Text := FormatFloat('###0.00', mb);
end;

procedure TformTrocear.LWEBClick2(Sender: TObject);
begin
  ShellExecute(Handle, Nil, PChar(LWEB.CAPTION),
      Nil, Nil, SW_SHOWNORMAL);
end;

procedure TformTrocear.bSeleccionarFicheroUnirClick(Sender: TObject);
begin
  dialogoAbrir.Title := 'Seleccione el primer fichero troceado...';
  dialogoAbrir.Filter := 'Ficheros troceados (*.trz)|*.trz|Todos los ficheros (*.*)|*.*|';
  if dialogoAbrir.Execute then
  begin
    txtFicheroUnir.Text := dialogoAbrir.FileName;
    FileSplitter.SplitFileName := txtFicheroUnir.Text;
    txtFicheroUnido.Text := FileSplitter.obtenerNombreFichero;
    lNumeroTrozos.Caption := 'N trozos: ' + floattostr(FileSplitter.ObtenerNumeroTrozos);
    if FileSplitter.ErrorUnir then
    begin
      txtFicheroUnido.Text := '';
      txtFicheroUnir.Text := '';
    end;
  end;
end;

procedure TformTrocear.FileSplitterProgress(Sender: TObject;
  PercentDone: Word);
begin
  bProgreso.Position := PercentDone;
  bProgreso.Refresh;
end;

procedure TformTrocear.FileSplitterNeedDisk(Sender: TObject; DiskID,
  NumOfDisks: Word; var Continue: Boolean);
begin
  lProceso.Caption := 'Procesando trozo ' +  inttostr(DiskID) +
      ' de ' + IntToStr(NumOfDisks);
  lProceso.Refresh;
  if (opDisquetes.Checked) or (deDisquete = true) then
  begin
    lProceso.Caption := 'Procesando disquete ' +  IntToStr(DiskID) +
        ' de ' + IntToStr(NumOfDisks) + '...';
    bProgreso.Position := 0;
    if (MessageDlg('Introduzca el disco ' + IntToStr(DiskID) +
        ' de ' + IntToStr(NumOfDisks) +
        ' y pulse "Aceptar".' + chr(13) + chr(13) +
        'Recuerde que el disquete debe tener espacio libre suficiente para ' +
        'aadir el trozo.',
        mtInformation, [mbOK, mbcancel], 0) = mrcancel) then
    begin
      if trocear then
      begin
        MessageDlg ('Ha cancelado el proceso de troceado del fichero. Los ' +
            'trozos hechos no servirn, deber volver a trocear el fichero.',
            mtWarning, [mbok], 0);
        Continue := false;
      end
      else
      begin
        MessageDlg ('Ha cancelado el proceso de unin de ficheros. El fichero unido no servir, deber borrarlo.',
            mtWarning, [mbok], 0);
        Continue := false;
      end;
    end
    else
      continue := true;
  end
  else
    exit;  // si no se utilizan disquetes, salimos
  Refresh;
  if not Continue then
  begin
    FileSplitter.Free;
    Application.Terminate;
    Halt;
    exit;
  end;
end;

procedure TformTrocear.FormShow(Sender: TObject);
begin
  Caption := vtNombreAplicacion;
  lVersion.Caption :=  vtNombreAplicacion + ' v. ' + vtVersionAplicacion;
  lstUnidadDisquete.ItemIndex := 0;
  bProgreso.Min := 1;
  bProgreso.Max := 100;
  deDisquete := false;
  if ParamStr(1) <> '' then  //si se ha hecho doble click a un fichero de extensin .trz
  begin
    txtFicheroUnir.Text := ParamStr(1);
    FileSplitter.SplitFileName := txtFicheroUnir.Text;
    txtFicheroUnido.Text := FileSplitter.obtenerNombreFichero;
    lNumeroTrozos.Caption := 'N trozos: ' + floattostr(FileSplitter.ObtenerNumeroTrozos);
    bUnirTrozosClick(nil);
  end;
end;

procedure TformTrocear.opDisquetesClick(Sender: TObject);
begin
  lstUnidadDisquete.Visible := opDisquetes.Checked;
  if FileExists(txtFicheroTrocear.Text) then
    if opDisquetes.Checked then
      txtFicheroTroceado.Text := lstUnidadDisquete.Text + '\' +
         ChangeFileExt(ExtractFileName(txtFicheroTrocear.Text), '.trz')
    else
      txtFicheroTroceado.Text := ChangeFileExt(txtFicheroTrocear.Text, '.trz')
  else
    txtFicheroTroceado.Text := '';
  tamanoFicheroNumTrozos();    
end;

procedure TformTrocear.txtTamanoChange(Sender: TObject);
begin
  tamanoFicheroNumTrozos();
end;

procedure TformTrocear.txtFicheroTrocearChange(Sender: TObject);
begin
  opDisquetesClick(nil);
end;

procedure TformTrocear.txtMegasChange(Sender: TObject);
begin
  try
    if txtMegas.Focused then
      txtTamano.Text := floattostr(round(strtofloat(txtMegas.Text) * 1048576));
  except
    txtTamano.Text := '';
  end;
end;

procedure TformTrocear.txtMegasKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = '.' then
    Key := ',';
end;

procedure TformTrocear.txtTamanoKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = '.' then
    Key := ',';
end;

procedure TformTrocear.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  escribeRegistro(HKEY_CURRENT_USER, '\SOFTWARE\AjpdSoft\' + vtNombreAplicacion,
        'Fichero a trocear', txtFicheroTrocear.Text, true);
  escribeRegistro(HKEY_CURRENT_USER, '\SOFTWARE\AjpdSoft\' + vtNombreAplicacion,
        'Nombre fichero troceado', txtFicheroTroceado.Text, true);
  escribeRegistro(HKEY_CURRENT_USER, '\SOFTWARE\AjpdSoft\' + vtNombreAplicacion,
        'Fichero a trocear', txtFicheroTrocear.Text, true);
  escribeRegistro(HKEY_CURRENT_USER, '\SOFTWARE\AjpdSoft\' + vtNombreAplicacion,
        'Tamao de los trozos', txtTamano.Text, true);
  escribeRegistro(HKEY_CURRENT_USER, '\SOFTWARE\AjpdSoft\' + vtNombreAplicacion,
        'Tamao megas', txtMegas.Text, true);
  if opDisquetes.Checked then
    escribeRegistro(HKEY_CURRENT_USER, '\SOFTWARE\AjpdSoft\' + vtNombreAplicacion,
          'Pasar a disquetes', '1', true)
  else
    escribeRegistro(HKEY_CURRENT_USER, '\SOFTWARE\AjpdSoft\' + vtNombreAplicacion,
          'Pasar a disquetes', '0', true);
  escribeRegistro(HKEY_CURRENT_USER, '\SOFTWARE\AjpdSoft\' + vtNombreAplicacion,
        'Unidad disquete', lstUnidadDisquete.Text, true);
  escribeRegistro(HKEY_CURRENT_USER, '\SOFTWARE\AjpdSoft\' + vtNombreAplicacion,
        'Fichero unir', txtFicheroUnir.Text, true);
  escribeRegistro(HKEY_CURRENT_USER, '\SOFTWARE\AjpdSoft\' + vtNombreAplicacion,
        'Fichero unido', txtFicheroUnido.Text, true);
end;

procedure TformTrocear.bAsociarExtensionClick(Sender: TObject);
   procedure RegistraExtension( Extension,
                                TipoFichero,
                                Descripcion,
                                Exe:string;
                                IndiceIcono: integer);
   {Uses: Registry, ShlObj}
   var
      Reg: TRegistry;
   begin
     Reg := TRegistry.Create;
     try
       with Reg do
       begin
         RootKey := HKEY_CLASSES_ROOT;
         OpenKey(Extension, True);
         WriteString('', TipoFichero);
         CloseKey;
         OpenKey(TipoFichero, True);
         WriteString('', Descripcion);
         CloseKey;
         OpenKey(TipoFichero + '\DefaultIcon', True);
         WriteString('', Exe + ',' + IntToStr(IndiceIcono));
         CloseKey;
         OpenKey(TipoFichero + '\Shell\Open', True);
         WriteString('', '&Open');
         CloseKey;
         OpenKey(TipoFichero + '\Shell\Open\Command', True);
         WriteString('', '"' + Exe + '" "%1"');
         CloseKey;
       end;
       SHChangeNotify( SHCNE_ASSOCCHANGED,
                       SHCNF_IDLIST,
                       nil, nil);
     finally
       Reg.Free;
     end;
   end;
begin
  RegistraExtension( '.trz',
                     'Trozos',
                     'Trozos de fichero para unir con AjpdSoft Trocear Fichero',
                     Application.ExeName,
                     0);
  MessageDlg('A partir de ahora, al hacer doble click sobre un fichero ' +
      'con extensin .trz se ejecutar este programa. Si cambia el programa ' +
      'de ubicacin deber volver a asociar la aplicacin.', mtInformation,
      [mbok], 0);
end;

procedure TformTrocear.lstUnidadDisqueteChange(Sender: TObject);
begin
  txtFicheroTroceado.Text := lstUnidadDisquete.Text + '\' +
      ExtractFileName(txtFicheroTroceado.Text);
end;

end.
